/*
 *  mappy.cpp
 *  MmapLib
 *
 *  Created by Blain Hamon on 5/19/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#include "mappy.h"
#include <stdio.h>

#include <mach/mach_init.h>
#include <mach/mach_port.h>
#include <mach/task.h>
#include <mach/thread_act.h>
#include <mach/vm_map.h>

#define BLOCK_SIZE 262144
#define BLOCK_OFFSET_MASK 262143
#define VM_TAG_FOR_COLLECTOR_MEMORY VM_MAKE_TAG(63)

extern "C"
kern_return_t __vm_map
(
	vm_map_t target_task,
	vm_address_t *address,
	vm_size_t size,
	vm_address_t mask,
	int flags,
	mem_entry_name_port_t object,
	vm_offset_t offset,
	boolean_t copy,
	vm_prot_t cur_protection,
	vm_prot_t max_protection,
	vm_inherit_t inheritance
)
{

//    vm_address_t _address = 0;
    // FIXME: tag the region as a TiCore heap when we get a registered VM tag: <rdar://problem/6054788>.
	printf("We wanted %d,%X,%X,%X,%X,%X,%X\n",current_task(), BLOCK_SIZE, BLOCK_OFFSET_MASK, VM_FLAGS_ANYWHERE | VM_TAG_FOR_COLLECTOR_MEMORY, VM_PROT_DEFAULT, VM_PROT_DEFAULT, VM_INHERIT_DEFAULT);
    kern_return_t result = vm_map(current_task(), address, BLOCK_SIZE, BLOCK_OFFSET_MASK, VM_FLAGS_ANYWHERE | VM_TAG_FOR_COLLECTOR_MEMORY, MEMORY_OBJECT_NULL, 0, FALSE, VM_PROT_DEFAULT, VM_PROT_DEFAULT, VM_INHERIT_DEFAULT);
	printf("ARRRGH Kern return t is %X, address is %X\n",result,*address);

//	int result=vm_map(target_task,address,size,mask,flags,object,offset,copy,cur_protection,max_protection,inheritance);
	return result;
};

void foo(){

    vm_address_t address = 0;
    // FIXME: tag the region as a TiCore heap when we get a registered VM tag: <rdar://problem/6054788>.
    kern_return_t result = __vm_map(current_task(), &address, BLOCK_SIZE, BLOCK_OFFSET_MASK, VM_FLAGS_ANYWHERE | VM_TAG_FOR_COLLECTOR_MEMORY, MEMORY_OBJECT_NULL, 0, FALSE, VM_PROT_DEFAULT, VM_PROT_DEFAULT, VM_INHERIT_DEFAULT);
	printf("Kern return t is %X, address is %X\n",result,address);


}